// Online C compiler to run C program online
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <inttypes.h>
#include <zephyr/logging/log.h>
#include <zephyr/logging/log_ctrl.h>

#define APPLICATION_LOG_LEVEL 5
struct k_timer my_timer;


LOG_MODULE_REGISTER(windoor_debug, APPLICATION_LOG_LEVEL);



#include <sys/types.h>

#define MAX_ALLOCATIONS 128

typedef struct {
    void *ptr;
    size_t size;
} allocation_entry_t;

static allocation_entry_t allocation_registry[MAX_ALLOCATIONS];

void register_allocation(void *ptr, size_t size) {
    for (int i = 0; i < MAX_ALLOCATIONS; i++) {
        if (allocation_registry[i].ptr == NULL) {
            allocation_registry[i].ptr = ptr;
            allocation_registry[i].size = size;
            return;
        }
    }
    // Handle registry overflow here, if needed.
}

void unregister_allocation(void *ptr) {
    for (int i = 0; i < MAX_ALLOCATIONS; i++) {
        if (allocation_registry[i].ptr == ptr) {
            allocation_registry[i].ptr = NULL;
            allocation_registry[i].size = 0;
            return;
        }
    }
    // Handle case where ptr is not found, if needed.
}

size_t get_allocation_size(void *ptr) {
    for (int i = 0; i < MAX_ALLOCATIONS; i++) {
        if (allocation_registry[i].ptr == ptr) {
            return allocation_registry[i].size;
        }
    }
    return 0; // If not found, consider handling this case.
}

void *custom_k_malloc(size_t size) {
    void *ptr = k_calloc(size, 1);
    if (ptr) {
        register_allocation(ptr, size);
    }
    return ptr;
}

void custom_k_free(void *ptr) {
    unregister_allocation(ptr);
    k_free(ptr);
}

void *custom_k_realloc(void *ptr, size_t new_size) {
    if (new_size == 0) {
        custom_k_free(ptr);
        return NULL;
    } else if (!ptr) {
        return custom_k_malloc(new_size);
    } else {
        size_t old_size = get_allocation_size(ptr);
        void *new_ptr = custom_k_malloc(new_size);
        if (!new_ptr) {
            return NULL; // Allocation failed
        }

        memcpy(new_ptr, ptr, old_size < new_size ? old_size : new_size);
        custom_k_free(ptr);
        LOG_ERR("New Size = %u", new_size);

        return new_ptr;
    }
}



char* p_alpha;

static void test_realloc(char **p_str)
{
    uint16_t size;
    char ins = 33;
    *p_str = custom_k_malloc(20);
    char* res = *p_str;

    for (size_t i = 0; i < 1335; i++)
    {
        size = strlen(res);
        res = custom_k_realloc(res, size + 2);
        res[size] = ins;
        res[size + 1] = '\0';
        ins++;
        if (ins == 125)
            ins = 34;
        LOG_DBG("size %u", size);

    }

    *p_str = res;
}
static void timer_callback()
{
	LOG_DBG("Test %c", p_alpha[10]);
}


int main() {


	//k_timer_init(&my_timer, timer_callback, NULL);

    test_realloc(&p_alpha);
    //LOG_DBG("ABCD");

    LOG_DBG("%s", p_alpha);
    LOG_PANIC();
    //free(p_alpha);
	//k_timer_start(&my_timer, K_MSEC(1000), K_MSEC(1000));
    return 0;
}
